
// BAJCheck.cpp 

// Defines the entry point for the application.

#include "stdafx.h"
#include "BAJCheck.h"
#include "Checker.h"
#include <mmsystem.h>
#include "GameList.h"
#include <commdlg.h>





#define CONST_AMOUNT_MAX 32
#define CONST_AMOUNT_HALF (CONST_AMOUNT_MAX / 2)
#define CONST_AMOUNT_SCALE (256 / CONST_AMOUNT_HALF)





#pragma comment(lib, "winmm.lib")





#define TIMER_FLASHICON 1

#define WC_MAIN TEXT("WC_BaJCheck_Main")





// Global Variables:
HINSTANCE gInstance;
HICON gIcoSmall;
HICON gIcoLarge;
HICON gIcoGreen;
HICON gTrayIcon = NULL;  // The lastly used custom tray icon (so that it can be deleted later)
HWND gWnd;
TSettings gSettings;
UINT gMsgTaskbarCreated;
int gStatus;
int gFlashIconIdx = 0;
bool gIsMyTurn = false;
int gNumMyTurns = 0;
ICONINFO gFlashIconInfo;
unsigned * gFlashIconImg = NULL;
unsigned * gRedIconImg = NULL;
unsigned * gGreenIconImg = NULL;
int gCXSmIcon = 16;
int gCYSmIcon = 16;
CGamePtrs gGameList;  // a copy of the current game list, as reported from CheckerThread





// Forward declarations of functions included in this code module:
BOOL             InitInstance  (void);
LRESULT CALLBACK WP_Main       (HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK    DP_Settings   (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void             AddTrayIcon   (void);
void             UpdateTrayIcon(void);
void             DelTrayIcon   (void);
void             LoadSettings  (void);
void             SaveSettings  (void);
void             ProcessGames  (CGamePtrs * iGames);





int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	gInstance = GetModuleHandle(NULL);
	if (!InitInstance()) 
	{
		return FALSE;
	}

	// Main message loop:
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	
	DelTrayIcon();
	SaveSettings();

	return (int) msg.wParam;
}





static int DDBToDIB(HBITMAP bmp, unsigned ** oData)
{
	BITMAP			bm;
	BITMAPINFOHEADER	bi;
	HDC 			hDC;

	// Get bitmap information
	GetObject(bmp, sizeof(bm), &bm);

	// Initialize the bitmapinfoheader
	bi.biSize		= sizeof(BITMAPINFOHEADER);
	bi.biWidth		= bm.bmWidth;
	bi.biHeight 		= bm.bmHeight;
	bi.biPlanes 		= 1;
	bi.biBitCount		= 32;
	bi.biCompression	= 0;
	bi.biSizeImage		= 0;
	bi.biXPelsPerMeter	= 0;
	bi.biYPelsPerMeter	= 0;
	bi.biClrUsed		= 0;
	bi.biClrImportant	= 0;

	// We need a device context to get the DIB from
	hDC = GetDC(NULL);

	bi.biSizeImage = ((((bi.biWidth * bi.biBitCount) + 31) & ~31) / 8) * bi.biHeight;
	*oData = (unsigned *)malloc(bi.biSizeImage);
	
	// FINALLY get the DIB
	BOOL bGotBits = GetDIBits(hDC, bmp,
		0L,				// Start scan line
		(DWORD)bi.biHeight,		// # of scan lines
		(LPBYTE)*oData, 			// address for bitmap bits
		(LPBITMAPINFO)&bi,		// address of bitmapinfo
		(DWORD)DIB_RGB_COLORS		// Use RGB for color table
	);

	if (!bGotBits)
	{
		free(*oData);
		*oData = NULL;
		
		ReleaseDC(NULL,hDC);
		return 0;
	}

	ReleaseDC(NULL,hDC);
	return bi.biSizeImage;
}





BOOL InitInstance(void)
{
	gCXSmIcon = GetSystemMetrics(SM_CXSMICON);
	gCYSmIcon = GetSystemMetrics(SM_CYSMICON);
	gIcoLarge = (HICON)LoadImage(gInstance, MAKEINTRESOURCE(IDI_BAJCHECK), IMAGE_ICON, GetSystemMetrics(SM_CXICON),   GetSystemMetrics(SM_CYICON),   LR_DEFAULTCOLOR | LR_SHARED);
	gIcoSmall = (HICON)LoadImage(gInstance, MAKEINTRESOURCE(IDI_BAJCHECK), IMAGE_ICON, gCXSmIcon, gCYSmIcon, LR_DEFAULTCOLOR | LR_SHARED);
	gIcoGreen = (HICON)LoadImage(gInstance, MAKEINTRESOURCE(IDI_GREEN),    IMAGE_ICON, gCXSmIcon, gCYSmIcon, LR_DEFAULTCOLOR | LR_SHARED);
	gMsgTaskbarCreated = RegisterWindowMessage(TEXT("TaskbarCreated"));
	
	// Prepare for icon fading:
	GetIconInfo(gIcoSmall, &gFlashIconInfo);
	BITMAPINFOHEADER bi;
	ZeroMemory(&bi, sizeof(bi));
	bi.biSize = sizeof(bi);
	bi.biWidth = gCXSmIcon;
	bi.biHeight = gCYSmIcon;
	bi.biBitCount = 32;
	bi.biPlanes = 1;
	HDC dc = GetDC(NULL);
	gFlashIconInfo.hbmColor = CreateDIBSection(dc, (LPBITMAPINFO)&bi, DIB_RGB_COLORS, (void **)&gFlashIconImg, 0, 0);
	ReleaseDC(NULL, dc);
	
	// Read the red & green icon pixel data:
	ICONINFO ii;
	GetIconInfo(gIcoSmall, &ii);
	unsigned int * Img = NULL;
	int NumBytes = DDBToDIB(ii.hbmColor, &gRedIconImg);
	if (NumBytes == 0)
	{
		return FALSE;
	}
	ICONINFO ii2;
	GetIconInfo(gIcoGreen, &ii2);
	NumBytes = DDBToDIB(ii2.hbmColor, &gGreenIconImg);
	if (NumBytes == 0)
	{
		return FALSE;
	}

	WNDCLASSEX wc;
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize        = sizeof(wc);
	wc.hInstance     = gInstance;
	wc.lpfnWndProc   = WP_Main;
	wc.lpszClassName = WC_MAIN;
	wc.hIcon         = gIcoLarge;
	wc.hIconSm       = gIcoSmall;
	if (RegisterClassEx(&wc) == 0)
	{
		return FALSE;
	}
	gWnd = CreateWindow(WC_MAIN, TEXT(""), WS_POPUP, 0, 0, 0, 0, NULL, NULL, gInstance, NULL);
	if (gWnd == NULL)
	{
		return FALSE;
	}

	// tray init:
	AddTrayIcon();
	
	LoadSettings();
	
	if (gSettings.Username[0] == 0)
	{
		// Show program settings if no username is set:
		PostMessage(gWnd, WM_COMMAND, IDM_SETTINGS, 0);
	}
	
	// checker initialization:
	if (!InitChecker())
	{
		return FALSE;
	}

	return TRUE;
}




void LoadSettings(void)
{
	// Fill in defaults:
	gSettings.Username[0] = 0;
	gSettings.NotifyIcon = true;
	gSettings.NotifySound = true;
	_tcsncpy(gSettings.SoundFile, TEXT("sheepbaa.wav"), ARRAYCOUNT(gSettings.SoundFile));
	
	// Try loading from file:
	TCHAR fnam[MAX_PATH];
	GetCurrentDirectory(ARRAYCOUNT(fnam), fnam);
	if (fnam[_tcslen(fnam) - 1] != TEXT('\\'))
	{
		_tcsncat(fnam, TEXT("\\"), ARRAYCOUNT(fnam));
	}
	_tcsncat(fnam, TEXT("BAJCheck.ini"), ARRAYCOUNT(fnam));
	if (GetFileAttributes(fnam) != INVALID_FILE_ATTRIBUTES)
	{
		gSettings.IsInFile = true;
		GetPrivateProfileString(TEXT("BAJCheck"), TEXT("Username"),  TEXT(""),             gSettings.Username,  ARRAYCOUNT(gSettings.Username),  fnam);
		GetPrivateProfileString(TEXT("BAJCheck"), TEXT("SoundFile"), TEXT("sheepbaa.wav"), gSettings.SoundFile, ARRAYCOUNT(gSettings.SoundFile), fnam);
		gSettings.NotifyIcon  = (GetPrivateProfileInt(TEXT("BAJCheck"), TEXT("NotifyIcon"),  1, fnam) != 0);
		gSettings.NotifySound = (GetPrivateProfileInt(TEXT("BAJCheck"), TEXT("NotifySound"), 1, fnam) != 0);
		return;
	}
	
	// Load from registry:
	HKEY Key;
	if (RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\_MadMaXoft(o)\\BAJCheck"), 0, NULL, 0, KEY_READ | KEY_WRITE, NULL, &Key, NULL) != ERROR_SUCCESS)
	{
		return;
	}
	DWORD Siz = sizeof(gSettings.Username);
	if (RegQueryValueEx(Key, TEXT("Username"), 0, NULL, (LPBYTE)gSettings.Username, &Siz) != ERROR_SUCCESS)
	{
		gSettings.Username[0] = 0;
	}
	
	Siz = sizeof(gSettings.SoundFile);
	if (RegQueryValueEx(Key, TEXT("SoundFile"), 0, NULL, (LPBYTE)gSettings.SoundFile, &Siz) != ERROR_SUCCESS)
	{
		_tcsncpy(gSettings.SoundFile, TEXT("sheepbaa.wav"), ARRAYCOUNT(gSettings.SoundFile));
	}
	
	DWORD val = 1;
	Siz = 4;
	RegQueryValueEx(Key, TEXT("NotifyIcon"), 0, NULL, (LPBYTE)&val, &Siz);
	gSettings.NotifyIcon = (val != 0);
	
	val = 1;
	Siz = 4;
	RegQueryValueEx(Key, TEXT("NotifySound"), 0, NULL, (LPBYTE)&val, &Siz);
	gSettings.NotifySound = (val != 0);
	
	RegCloseKey(Key);

	gSettings.IsInFile = false;
}





void SaveSettings(void)
{
	if (gSettings.IsInFile)
	{
		// Save to local ini file:
		TCHAR fnam[MAX_PATH];
		GetCurrentDirectory(ARRAYCOUNT(fnam), fnam);
		if (fnam[_tcslen(fnam) - 1] != TEXT('\\'))
		{
			_tcsncat(fnam, TEXT("\\"), ARRAYCOUNT(fnam));
		}
		_tcsncat(fnam, TEXT("BAJCheck.ini"), ARRAYCOUNT(fnam));
		WritePrivateProfileString(TEXT("BAJCheck"), TEXT("Username"),    gSettings.Username,  fnam);
		WritePrivateProfileString(TEXT("BAJCheck"), TEXT("SoundFile"),   gSettings.SoundFile, fnam);
		WritePrivateProfileString(TEXT("BAJCheck"), TEXT("NotifyIcon"),  gSettings.NotifyIcon  ? TEXT("1") : TEXT("0"), fnam);
		WritePrivateProfileString(TEXT("BAJCheck"), TEXT("NotifySound"), gSettings.NotifySound ? TEXT("1") : TEXT("0"), fnam);
	}
	else
	{
		// Save to registry:
		HKEY Key;
		if (RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\_MadMaXoft(o)\\BAJCheck"), 0, NULL, 0, KEY_READ | KEY_WRITE, NULL, &Key, NULL) != ERROR_SUCCESS)
		{
			return;
		}
		RegSetValueEx(Key, TEXT("UserName"),  0, REG_SZ, (LPBYTE)gSettings.Username,  (_tcslen(gSettings.Username)  + 1) * sizeof(TCHAR));
		RegSetValueEx(Key, TEXT("SoundFile"), 0, REG_SZ, (LPBYTE)gSettings.SoundFile, (_tcslen(gSettings.SoundFile) + 1) * sizeof(TCHAR));
		DWORD val = gSettings.NotifyIcon ? 1 : 0;
		RegSetValueEx(Key, TEXT("NotifyIcon"), 0, REG_DWORD, (LPBYTE)&val, 4);
		val = gSettings.NotifySound ? 1 : 0;
		RegSetValueEx(Key, TEXT("NotifySound"), 0, REG_DWORD, (LPBYTE)&val, 4);
		RegCloseKey(Key);
	}
	SetEvent(gEvtCheck);
}





void AddTrayIcon(void)
{
	NOTIFYICONDATA nid;
	ZeroMemory(&nid, sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = gWnd;
	nid.uID = 1;
	nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	nid.uCallbackMessage = MYM_TRAYICON;
	nid.hIcon = gIcoSmall;
	_tcscpy(nid.szTip, TEXT("BAJCheck"));
	Shell_NotifyIcon(NIM_ADD, &nid);
}





void UpdateTrayIcon(void)
{
	NOTIFYICONDATA nid;
	ZeroMemory(&nid, sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = gWnd;
	nid.uID = 1;
	nid.uFlags = NIF_MESSAGE | NIF_TIP;
	nid.uCallbackMessage = MYM_TRAYICON;
	_sntprintf(nid.szTip, ARRAYCOUNT(nid.szTip), TEXT("BAJCheck - %d games waiting"), gNumMyTurns);
	Shell_NotifyIcon(NIM_MODIFY, &nid);
}





void DelTrayIcon(void)
{
	NOTIFYICONDATA nid;
	ZeroMemory(&nid, sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = gWnd;
	nid.uID = 1;
	Shell_NotifyIcon(NIM_DELETE, &nid);
}





void SetTrayIcon(HICON iIcon)
{
	NOTIFYICONDATA nid;
	ZeroMemory(&nid, sizeof(nid));
	nid.cbSize = sizeof(nid);
	nid.hWnd = gWnd;
	nid.uID = 1;
	nid.uFlags = NIF_ICON;
	nid.hIcon = iIcon;
	Shell_NotifyIcon(NIM_MODIFY, &nid);
}





void PopupTrayMenu(void)
{
	HMENU menu = LoadMenu(gInstance, MAKEINTRESOURCE(IDM_BAJCHECK));
	if (menu == NULL)
	{
		return;
	}
	menu = GetSubMenu(menu, 0);
	POINT pnt;
	GetCursorPos(&pnt);
	SetForegroundWindow(gWnd);
	TrackPopupMenu(menu, TPM_RIGHTBUTTON, pnt.x, pnt.y, 0, gWnd, NULL);
}





static unsigned MixColor(unsigned iSrc, unsigned iDest, int Amount)
{
	int r = iSrc & 0xff;
	int g = (iSrc >> 8) & 0xff;
	int b = (iSrc >> 16) & 0xff;
	int rd = iDest & 0xff;
	int gd = (iDest >> 8) & 0xff;
	int bd = (iDest >> 16) & 0xff;
	int nr = r + (rd - r) * Amount / 256;
	int ng = g + (gd - g) * Amount / 256;
	int nb = b + (bd - b) * Amount / 256;
	return nr | (ng << 8) | (nb << 16);
}





static void FlashIcon(void)
{
	gFlashIconIdx++;
	if (gFlashIconIdx >= CONST_AMOUNT_MAX)
	{
		gFlashIconIdx = 0;
	}
	int Amount = (gFlashIconIdx < CONST_AMOUNT_HALF) ? gFlashIconIdx : CONST_AMOUNT_MAX - gFlashIconIdx;
	int NumPixels = gCXSmIcon * gCYSmIcon;
	for (int i = 0; i < NumPixels; i++)
	{
		gFlashIconImg[i] = MixColor(gRedIconImg[i], gGreenIconImg[i], Amount * CONST_AMOUNT_SCALE);
	}
	HICON ico = CreateIconIndirect(&gFlashIconInfo);
	SetTrayIcon(ico);
	DeleteObject(gTrayIcon);
	gTrayIcon = ico;
}





static void StartFlashingIcon(void)
{
	gFlashIconIdx = 0;
	SetTimer(gWnd, TIMER_FLASHICON, 100, NULL);
}





static void StopFlashingIcon(void)
{
	KillTimer(gWnd, TIMER_FLASHICON);
	SetTrayIcon(gIcoSmall);
}





LRESULT CALLBACK WP_Main(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) 
	{
		case WM_COMMAND:
		{
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			
			switch (wmId)
			{
				case IDM_GAMELIST:
				{
					ShowGameList();
					break;
				}
				case IDM_SETTINGS:
				{
					DialogBox(gInstance, MAKEINTRESOURCE(IDD_SETTINGS), gWnd, (DLGPROC)DP_Settings);
					SaveSettings();
					break;
				}
				case IDM_EXIT:
				{
					DestroyWindow(gWnd);
					break;
				}
				default:
				{
					return DefWindowProc(hWnd, message, wParam, lParam);
				}
			}
			break;
		}
		
		case WM_DESTROY:
		{
			PostQuitMessage(0);
			gShouldRun = false;
			SetEvent(gEvtCheck);
			WaitForSingleObject(gCheckerThread, 10000);
			break;
		}
		
		case WM_TIMER:
		{
			switch (wParam)
			{
				case TIMER_FLASHICON:
				{
					FlashIcon();
					break;
				}		// case TIMER_FLASHICON
			}		// switch (TimerID)
			return 0;
		}
		
		case MYM_TRAYICON:
		{
			switch (lParam)
			{
				case WM_RBUTTONUP:
				{
					StopFlashingIcon();
					PopupTrayMenu();
					break;
				}
				case WM_LBUTTONDBLCLK:
				case WM_RBUTTONDBLCLK:
				{
					StopFlashingIcon();
					ShowGameList();
					break;
				}
			}
			return 0;
		}
		
		case MYM_NOTIFY:
		{
			ProcessGames((CGamePtrs *)lParam);
			return 0;
		}
		
		default:
		{
			if (message == gMsgTaskbarCreated)
			{
				AddTrayIcon();
				return 0;
			}
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
	}
	return 0;
}





void ApplySettings(HWND iWnd)
{
	EnterCriticalSection(&(gSettings.cs));
	SetDlgItemText(iWnd, IDC_E_USERNAME,    gSettings.Username);
	CheckDlgButton(iWnd, IDC_CHB_FLASHICON, gSettings.NotifyIcon  ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(iWnd, IDC_CHB_PLAYSOUND, gSettings.NotifySound ? BST_CHECKED : BST_UNCHECKED);
	SetDlgItemText(iWnd, IDC_E_SOUNDFILE,   gSettings.SoundFile);
	LeaveCriticalSection(&(gSettings.cs));
}





void RetrieveSettings(HWND iWnd)
{
	EnterCriticalSection(&(gSettings.cs));
	HWND ctl = GetDlgItem(iWnd, IDC_E_USERNAME);
	GetWindowText(ctl, gSettings.Username, ARRAYCOUNT(gSettings.Username));
	
	gSettings.NotifyIcon  = IsDlgButtonChecked(iWnd, IDC_CHB_FLASHICON) == BST_CHECKED;
	gSettings.NotifySound = IsDlgButtonChecked(iWnd, IDC_CHB_PLAYSOUND) == BST_CHECKED;
	
	ctl = GetDlgItem(iWnd, IDC_E_SOUNDFILE);
	GetWindowText(ctl, gSettings.SoundFile, ARRAYCOUNT(gSettings.SoundFile));
	LeaveCriticalSection(&(gSettings.cs));
}





BOOL CALLBACK DP_Settings(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
		{
			ApplySettings(hDlg);
			SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)gIcoSmall);
			SendMessage(hDlg, WM_SETICON, ICON_BIG,   (LPARAM)gIcoLarge);
			return TRUE;
		}

		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
				case IDOK:
				{
					RetrieveSettings(hDlg);
					// Fall through!
				}
				case IDCANCEL:
				{
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
				}
				
				case IDC_TL_PLAY:
				{
					TCHAR fnam[MAX_PATH];
					GetDlgItemText(hDlg, IDC_E_SOUNDFILE, fnam, ARRAYCOUNT(fnam));
					PlaySound(fnam, NULL, SND_FILENAME | SND_ASYNC);
					return TRUE;
				}
				
				case IDC_TL_BROWSE:
				{
					TCHAR fnam[MAX_PATH];
					GetDlgItemText(hDlg, IDC_E_SOUNDFILE, fnam, ARRAYCOUNT(fnam));
					OPENFILENAME ofn;
					ZeroMemory(&ofn, sizeof(ofn));
					ofn.lStructSize = sizeof(ofn);
					ofn.hInstance = gInstance;
					ofn.hwndOwner = hDlg;
					ofn.Flags = OFN_FILEMUSTEXIST;
					ofn.lpstrFile = fnam;
					ofn.nMaxFile = ARRAYCOUNT(fnam);
					ofn.lpstrDefExt = TEXT("*.wav");
					ofn.lpstrFilter = TEXT("Wave file\0*.wav\0");
					if (GetOpenFileName(&ofn))
					{
						SetDlgItemText(hDlg, IDC_E_SOUNDFILE, fnam);
					}
					return TRUE;
				}
			}
			break;
		}
	}
	return FALSE;
}





void ProcessGames(CGamePtrs * iGames)
{
	// Match gGameList with iGame list to disable notification for games that have been already notified
	for (CGamePtrs::iterator itr = iGames->begin(); itr != iGames->end(); ++itr)
	{
		for (CGamePtrs::iterator itr2 = gGameList.begin(); itr2 != gGameList.end(); ++itr2)
		{
			if ((*itr)->PartieID.compare((*itr2)->PartieID) != 0)
			{
				continue;
			}
			(*itr)->HasBeenNotified = (*itr2)->HasBeenNotified && (*itr2)->IsMyTurn;
		}  // for itr2 - gGameList[]
	}  // for itr - iGames[]
	
	for (CGamePtrs::iterator itr = gGameList.begin(); itr != gGameList.end(); ++itr)
	{
		delete *itr;
	}
	gGameList.clear();
	
	// Duplicate the chain into gGameList, and count the MyTurn games:
	gNumMyTurns = 0;
	int NumNotify = 0;
	for (CGamePtrs::iterator itr = iGames->begin(); itr != iGames->end(); ++itr)
	{
		CGame * g = new CGame(**itr);
		gGameList.push_back(g);

		if (g->IsMyTurn)
		{
			gNumMyTurns++;
			if (!(*itr)->HasBeenNotified)
			{
				NumNotify++;
			}
		}
		g->HasBeenNotified = true;
	}

	gIsMyTurn = (gNumMyTurns > 0);

	if (NumNotify > 0)
	{
		// Notify of turn:
		if (gSettings.NotifyIcon)
		{
			StartFlashingIcon();
		}
		if (gSettings.NotifySound)
		{
			if ((gSettings.SoundFile == NULL) || (gSettings.SoundFile[0] == 0))
			{
				PlaySound(TEXT(""), gInstance, SND_FILENAME | SND_ASYNC);
			}
			else
			{
				PlaySound(gSettings.SoundFile, NULL, SND_FILENAME | SND_ASYNC);
			}
		}
	}
	else if (gNumMyTurns == 0)
	{
		StopFlashingIcon();
	}

	UpdateTrayIcon();
}








