#pragma once

#include "resource.h"
#include "Game.h"





#define MYM_TRAYICON (WM_USER + 10)		// tray icon notification msg
#define MYM_NOTIFY   (WM_USER + 11)		// checker thread turn notification; LPARAM = TGame *

#define CHECK_INTERVAL_SEC  (5 * 60)		// 5 minutes
#define CHECK_INTERVAL_MSEC (CHECK_INTERVAL_SEC * 1000)

#define STATUS_NOTURN 0
#define STATUS_TURN 1
#define STATUS_OFFLINE -1
#define STATUS_PARSEERROR -2





struct TSettings
{
	CRITICAL_SECTION cs;
	TCHAR Username[300];
	bool NotifyIcon;
	bool NotifySound;
	TCHAR SoundFile[MAX_PATH];
	bool IsInFile;
} ;





// Global Variables:
extern HINSTANCE gInstance;
extern HICON gIcoSmall;
extern HICON gIcoLarge;
extern HICON gIcoGreen;
extern HWND gWnd;
extern TSettings gSettings;
extern UINT gMsgTaskbarCreated;
extern int gStatus;
extern CGamePtrs gGameList;  // a copy of the current game list, as reported from CheckerThread




