
// Checker.cpp

// implements the BAJ checker thread

#include "stdafx.h"
#include "BAJCheck.h"
#include "Checker.h"
#include "strnstr.h"
#include "Game.h"




#pragma comment(lib, "wininet.lib")





// globals:
HANDLE gEvtCheck;
HANDLE gCheckerThread;
HINTERNET gInternet;
bool gShouldRun = true;





const char * strnchr(const char * iStr, char chr, int iLen)
{
	for (int i = 0; i < iLen; i++)
	{
		if (iStr[i] == chr)
		{
			return iStr + i;
		}
	}
	return NULL;
}





bool InitChecker(void)
{
	InitializeCriticalSection(&(gSettings.cs));
	gEvtCheck = CreateEvent(NULL, FALSE, TRUE, NULL);
	gInternet = InternetOpen(NULL, INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if (gInternet == NULL)
	{
		MessageBox(NULL, _T("Cannot initialize internet connection!"), _T("BAJCheck Error"), MB_ICONERROR);
		return false;
	}
	DWORD ThreadID;
	gCheckerThread = CreateThread(NULL, 0, CheckerThread, NULL, CREATE_SUSPENDED, &ThreadID);
	ResumeThread(gCheckerThread);
	return true;
}





int Download(char * Buf, size_t BufLen, LPCTSTR iUsername)
{
	int ret = -1;
	
	LPCTSTR AcceptTypes[] =
	{
		_T("*/*"),
		NULL
	} ;
	
	HINTERNET hConn = InternetConnect(gInternet, _T("www.boiteajeux.net"), 80, NULL, NULL, INTERNET_SERVICE_HTTP, 0, 0);
	if (hConn == NULL)
	{
		gStatus = STATUS_OFFLINE;
		goto Cleanup;
	}
	
	HINTERNET hReq = HttpOpenRequest(hConn, _T("POST"), _T("/index.php?p=recherche"), _T("1.0"), NULL, AcceptTypes, INTERNET_FLAG_NO_UI | INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_NO_AUTH, 0);
	if (hReq == NULL)
	{
		gStatus = STATUS_OFFLINE;
		goto Cleanup;
	}
	
	
	int FormDataLen;
	
	#ifdef _UNICODE
	FormDataLen = _snprintf(Buf, BufLen, "pJeu=&pLoginJ=%ls&pidP=&pLibP=&pEtat=2", iUsername);
	#else
	FormDataLen = _snprintf(Buf, BufLen, "pJeu=&pLoginJ=%s&pidP=&pLibP=&pEtat=2", iUsername);
	#endif
	
	HttpAddRequestHeaders(hReq, _T("Content-Type: application/x-www-form-urlencoded"), -1, HTTP_ADDREQ_FLAG_REPLACE | HTTP_ADDREQ_FLAG_ADD_IF_NEW);
	
	if (!HttpSendRequest(hReq, NULL, 0, Buf, FormDataLen))
	{
		gStatus = STATUS_OFFLINE;
		goto Cleanup;
	}
	
	int Status;
	DWORD StatusSize = sizeof(Status);
	HttpQueryInfo(hReq, HTTP_QUERY_STATUS_CODE | HTTP_QUERY_FLAG_NUMBER, &Status, &StatusSize, NULL);
	if ((Status / 100) != 2)
	{
		gStatus = STATUS_OFFLINE;
		goto Cleanup;
	}
	
	char * BufPos = Buf;
	DWORD BufLeft = (DWORD)BufLen;
	DWORD br;
	while ((BufLeft > 0) && InternetReadFile(hReq, BufPos, BufLeft, &br))
	{
		if (!gShouldRun || (br == 0))
		{
			break;
		}
		BufPos += br;
		BufLeft -= br;
	}
	ret = (int)(BufPos - Buf);
	if (ret < 100)
	{
		ret = -1;
		gStatus = STATUS_OFFLINE;
		goto Cleanup;
	}

	/*
	// DEBUG:
	FILE * f = fopen("c:\\BAJ.html", "wb");
	if (f != NULL)
	{
		fwrite(Buf, ret, 1, f);
		fclose(f);
	}
	//*/
	
	Cleanup:
	InternetCloseHandle(hReq);
	InternetCloseHandle(hConn);
	return ret;
}




LPSTR FormUrlEncode(LPCTSTR txt)
{
	int len = (int)_tcslen(txt);
	char * dst = (char *)malloc(len * 4 + 1);
	if (dst == NULL)
	{
		return NULL;
	}
	
	char * src;
	#ifdef _UNICODE
	src = malloc(len * 4 + 1);
	if (src == NULL)
	{
		free(dst);
		return NULL;
	}
	len = WideCharToMultiByte(CP_UTF8, 0, txt, -1, src, len * 4 + 1, NULL, NULL);
	#else
	src = (char *)txt;
	#endif		// !_UNICODE
	
	int j = 0;
	const char * HexChar = "0123456789abcdef";
	for (int i = 0; i < len; i++)
	{
		if ((src[i] < 32) || ((unsigned char)(src[i]) > 127) || (src[i] == '+') || (src[i] == '&'))
		{
			dst[j] = '%';
			dst[j + 1] = HexChar[src[i] >> 4];
			dst[j + 2] = HexChar[src[i] & 0x0f];
			j += 3;
		}
		else if (src[i] == ' ')
		{
			dst[j] = '+';
			j++;
		}
		else
		{
			dst[j] = src[i];
			j++;
		}
	}		// for i - src[]
	dst[j] = 0;
	
	#ifdef _UNICODE
	free(src);
	#endif
	
	return dst;
}





void ParseGamePlayers(const char * iBuf, const char * iLCBuf, const char * iFrom, const char * iTo, CGamePtr iGame)
{
	// Fill in players present in a game
	/*
	iBuf - the original downloaded data
	iLCBuf - the lowercased data, 1:1 to iBuf (so that pointer differencing can work)
	iFrom - pointer to inside iLCBuf where to start parsing
	iTo - pointer to inside iLCBuf where to stop parsing
	iGame - the game object where to put players
	*/
	static const char * match = "onclick=\"detailjoueur(";
	const char * from;
	const char * next = strnstr(iFrom, match, iTo - iFrom);
	if (next == NULL)
	{
		return;
	}
	next += strlen(match);
	while (next != NULL)
	{
		if (!gShouldRun)
		{
			return;
		}
		from = next + strlen(match);
		next = strnstr(from, match, iTo - from);
		const char * to = (next == NULL) ? iTo : next;
		// Search between from and next for a UserName and UserID
		const char * UserIDEnd = strnchr(from, ')', to - from);
		if (UserIDEnd == NULL)
		{
			break;
		}
		// The UserID is between from and UserIDEnd
		
		const char * match2 = "<span ";
		const char * UserNameStart = strnstr(from, match2, to - from);
		if (UserNameStart == NULL)
		{
			break;
		}
		const char * Orig = UserNameStart;
		UserNameStart = strnchr(UserNameStart, '>', to - UserNameStart);
		if (UserNameStart == NULL)
		{
			break;
		}
		UserNameStart++;
		const char * UserNameEnd = strnchr(UserNameStart, '<', to - UserNameStart);
		if (UserNameEnd == NULL)
		{
			break;
		}
		// The UserName is between UserNameStart and UserNameEnd
		
		bool IsOnTurn = (UserNameStart - Orig) > 20;  // The span specification is longer than 20 chars, suppose that's because it's the user's turn
		
		std::string Name(iBuf + (UserNameStart - iLCBuf), UserNameEnd - UserNameStart);
		std::string ID(from, UserIDEnd - from);
		CPlayerPtr p = new CPlayer(Name, ID, IsOnTurn);
		iGame->Players.push_back(p);
	}  // while (1)
	// TODO
}





void ParseSingleGameType(const char * iBuf, const char * iLCBuf, char * iFrom, int iLen, CGamePtrs & oGame, const char * iUsername, const char * iGameType)
{
	/*
	iBuf - the original downloaded data
	iLCBuf - the lowercased data, 1:1 to iBuf (so that pointer differencing can work)
	iFrom - pointer to inside of iLCBuf where to start game parsing
	iLen - length (in characters, from iFrom) to parse for games
	oGame - output games here
	iUsername - LC username
	iGameType - copy this into each created game's Type
	*/
	
	const char * match = "img/ico_encours.gif";
	int MatchLen = (int)strlen(match);
	char * from = (char *)strnstr(iFrom, match, iLen);
	char * next = from;
	while(1)
	{
		if (!gShouldRun)
		{
			return;
		}
		from = next;
		if (from == NULL)
		{
			break;
		}
		next = (char *)strnstr(from + MatchLen, match, iLen - (from - iFrom));
		char * to = (next == NULL) ? iFrom + iLen : next;
		
		// parse from "from" to "to"
		int len = (int)(to - from);
		
		// find game URL:
		char * href = (char *)strnstr(from, "href=", len);
		if (href == NULL)
		{
			continue;
		}
		href += 6;
		const char * hrefend = strnchr(href, '\"', (int)(to - href));
		if (hrefend == NULL)
		{
			continue;
		}
		if (hrefend == href + 1)
		{
			href++;
			hrefend = strnchr(hrefend + 1, '\"', (int)(to - hrefend));
		}
		int hreflen = (int)(hrefend - href);
		
		// find the player on turn
		char * TurnSpan = (char *)strnstr(from, "font-weight:bold", len);
		if (TurnSpan == NULL)
		{
			continue;
		}
		char * SpanEnd = (char *)strnstr(TurnSpan, "</span", to - TurnSpan);
		if (SpanEnd == NULL)
		{
			continue;
		}
		char * MyNickOnTurn = (char *)strnstr(TurnSpan, iUsername, SpanEnd - TurnSpan);
		const char * PartieID = strnstr(href, "?id=", hreflen);
		if (PartieID != NULL)
		{
			PartieID += 4;
		}
		
		// add the game to list:
		
		CGamePtr g = new CGame(href, hreflen, PartieID, iGameType, (MyNickOnTurn != NULL));
		
		ParseGamePlayers(iBuf, iLCBuf, from, to, g);
		
		oGame.push_back(g);
	}
}





void Parse(const char * iBuf, int iLen, CGamePtrs & oGame, const char * iUsername)
{
	// Make a lowercase copy of the strings:
	char * Buf = (char *)malloc(iLen);
	memcpy(Buf, iBuf, iLen);
	CharLowerBuffA(Buf, iLen);
	char * Username = _strdup(iUsername);
	CharLowerBuffA(Username, (DWORD)strlen(Username));
	
	char * start = (char *)strnstr(Buf, "recherche de parties", iLen);
	if (start == NULL)
	{
		gStatus = STATUS_PARSEERROR;
		return;
	}
	int NewLen = (iLen - (start - Buf));
	
	// Search for game types:
	const char * match = "class=cllisteentete";
	int MatchLen = (int)strlen(match);
	char * from = (char *)strnstr(start, match, iLen);
	char * next = from;
	while(1)
	{
		from = next;
		if (from == NULL)
		{
			break;
		}
		from += MatchLen;
		next = (char *)strnstr(from, match, iLen - (from - start));
		char * to = (next == NULL) ? Buf + iLen : next;
		
		// Find the GameType:
		int len = (int)(to - from);
		const char * GT = strnstr(from, "&nbsp;&nbsp;", len);
		if (GT == NULL)
		{
			break;
		}
		GT += 12;
		const char * GTE = strnchr(GT, '<', (int)(to - GT));
		if (GTE == NULL)
		{
			break;
		}
		int GTLen = (int)(GTE - GT + 1);
		char * GameType = (char *)malloc(GTLen);
		ZeroMemory(GameType, GTLen);
		strncpy(GameType, iBuf + (GT - Buf), GTLen - 1);
		
		// Parse single game type from "from" to "to"
		ParseSingleGameType(iBuf, Buf, from, len, oGame, Username, GameType);
		free(GameType);
	}
}





DWORD __stdcall CheckerThread(void * iParam)
{
	while(gShouldRun)
	{
		WaitForSingleObject(gEvtCheck, CHECK_INTERVAL_MSEC);
		if (!gShouldRun)
		{
			break;
		}
		
		EnterCriticalSection(&(gSettings.cs));
			LPSTR Username = FormUrlEncode(gSettings.Username);
		LeaveCriticalSection(&(gSettings.cs));
		
		char Buf[128 * 1024];		// typical output is ~40 KB
		int Num = Download(Buf, sizeof(Buf), Username);

		if (Num <= 0)
		{
			free(Username);
			continue;
		}
		
		CGamePtrs Games;
		Parse(Buf, Num, Games, Username);
		free(Username);
		if (Games.empty() != 0)
		{
			continue;
		}
		
		SendMessage(gWnd, MYM_NOTIFY, 0, (LPARAM)&Games);
		
		for (CGamePtrs::iterator itr = Games.begin(); itr != Games.end(); ++itr)
		{
			delete *itr;
		}
	}
	return 0;
}




